/*******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2012.

	This file is part of LibMaxsi.

	LibMaxsi is free software: you can redistribute it and/or modify it under
	the terms of the GNU Lesser General Public License as published by the Free
	Software Foundation, either version 3 of the License, or (at your option)
	any later version.

	LibMaxsi is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
	details.

	You should have received a copy of the GNU Lesser General Public License
	along with LibMaxsi. If not, see <http://www.gnu.org/licenses/>.

	abs.cpp
	Allows taking the absolute value of integer types.

*******************************************************************************/

#include <stdint.h>
#include <stdlib.h>
#include <inttypes.h>

template <class T> T Absolute(T t)
{
	return t < 0 ? -t : t;
}

extern "C" int abs(int val) { return Absolute(val); }
extern "C" long int labs(long int val) { return Absolute(val); }
extern "C" long long int llabs(long long int val) { return Absolute(val); }
extern "C" intmax_t imaxabs(intmax_t val) { return Absolute(val); }

